class A:
    def f1(self):
        return "f1"

    def f2(self):
        return "f2"

    def sep(self):
        return ":"

    def f3(self):
        return f"{self.f1()} {self.sep()} {self.f2()}"

class B(A):
    def f1(self):
        return f"{super().f1()} de B"

    def sep(self):
        return "-"

class MonDict(dict):
    def __setitem__(self, key, value):
        if isinstance(key, str):
            super().__setitem__(key.upper(), value)

from collections.abc import Iterator, Iterable


# Héritage multiple


class C(A):
    def f2(self):
        return f"{super().f2()} de C"

    def sep(self):
        return ";"

class D(B, C):
    ...

class E(C, B):
    ...


class AllZero(Iterator):
    def __next__(self):
        return 0


class Cycle(Iterator):
    def __init__(self, values: list):
        self.values = values
        self.indice = 0

    def __next__(self):
        res = self.values[self.indice]
        self.indice = (self.indice + 1)% len(self.values)
        return res 

class MesStr(Iterable, str):
    def __iter__(self):
        return Cycle(self)
